<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="de">
  <head>
    <meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
    <title>Rezept hinzufgen</title>
    <meta name="author" content="Thiemo Mttig">
    <meta name="robots" content="noindex,nofollow">
    <link rel="stylesheet" type="text/css" href="beispiel-rezepte.css">
  </head>
  <body>

    <h1>Rezept hinzufgen</h1>

    <div class="tabellennavigation">
      <a href="beispiel-rezepte.php">&lt; Zurck zu den Rezepten</a>
    </div>

<?php

// Die bentigten Formular- und Tabellen-Funktionen werden eingebunden.
require_once("Apeform.class.php");
require_once("MyCSV.class.php");

// Die Tabellen-Datei wird geladen.
$tabellendatei = isset($_SERVER['PHP_SELF']) ? $_SERVER['PHP_SELF'] : $PHP_SELF;
$tabellendatei = preg_replace('/(-neu)?\.\w*$/i', '', basename($tabellendatei));
$tabelle = new MyCSV($tabellendatei);

// Ein neuer leerer Datensatz wird vorbereitet.
$neuer_datensatz = array();

// Ein neues Formular wird erzeugt und mit besonderen HTML-Templates gefttert.
$formular = new Apeform(0, 0, "", false);
$formular->templates = array(
    'form'  => "\n  <div class=\"datensatz\">\n{input}  </div>\n",
    'input' => "    <div class=\"{help}\">\n      {label}\n      {input}\n    </div>\n",
    'label' => "{label}:<br>\n      ",
    'error' => "<strong>{error}:</strong><br>\n      ");

// Fr jede Spalte in der Tabelle wird ein Formularfeld erzeugt.
foreach ($tabelle->fields as $spaltenname)
{
    // Die erste Spalte mit der ID-Nummer wird bersprungen.
    if (strtolower($spaltenname) == "id") continue;

    // Der fr den Anwender sichtbare Spaltentitel wird vorbereitet.
    $spaltentitel = ucfirst(str_replace("_", " ", $spaltenname));

    // Klassennamen drfen in erster Linie keine Leerzeichen enthalten.
    $class = preg_replace('/[^a-z0-9_-]+/is', '', $spaltenname);

    // Das Formularfeld wird erzeugt und gleichzeitig die Eingabe ausgelesen.
    $neuer_datensatz[$spaltenname] = &$formular->textarea($spaltentitel, $class);
    $neuer_datensatz[$spaltenname] =
        preg_replace('/\s*\n/sU', "\n", trim($neuer_datensatz[$spaltenname]));

    // Wenn die Spalte als gefordert (z.B. "Name*") gekennzeichnet wurde.
    if (substr($spaltenname, -1) == "*" && empty($neuer_datensatz[$spaltenname]))
    {
        $formular->error();
    }
}

// Das letzte Formularelement soll der Knopf zum Speichern sein.
$formular->submit("Datensatz speichern");

// Komplett leere Datenstze ergeben keinen Sinn und werden ignoriert.
if (! $formular->isValid() || ! implode("", $neuer_datensatz))
{
    // Das Formular wird erst hier angezeigt, wenn noch nichts eingegeben wurde.
    $formular->display();
}
else
{
    // Wenn so ein Datensatz noch nicht existiert, wird er gespeichert.
    if (! $tabelle->row_exists($neuer_datensatz))
    {
        if (isset($neuer_datensatz['Datum']) && empty($neuer_datensatz['Datum']))
        {
            $neuer_datensatz['Datum'] = date("Y-m-d");
        }
        if (isset($neuer_datensatz['Uhrzeit']) && empty($neuer_datensatz['Uhrzeit']))
        {
            $neuer_datensatz['Uhrzeit'] = date("Y-m-d H:i");
        }
        $tabelle->insert($neuer_datensatz);
        if (! @$tabelle->write())
        {
            echo "<p>Es ist ein technisches Problem aufgetreten: ";
            echo "Die Tabelle kann nicht erstellt/geffnet werden.</p>";
        }
        else
        {
            echo "<p>Der neue Datensatz wurde erfolgreich gespeichert.</p>";
        }
    }
}

?>

  </body>
</html>