<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="de">
  <head>
    <meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
    <title>Rezepte</title>
    <meta name="author" content="Thiemo Mttig">
    <meta name="robots" content="noindex,nofollow">
    <link rel="stylesheet" type="text/css" href="beispiel-rezepte.css">
  </head>
  <body>

    <h1>Rezepte</h1>

    <div class="tabellennavigation">
      <a href="beispiel-rezepte-neu.php">Neues Rezept hinzufgen</a>
    </div>

<?php

// Hier kann bestimmt werden, wie viele Datenstze auf eine Seite passen.
$datensaetze_je_seite = 5;

// Die bentigten Tabellen-Funktionen werden eingebunden.
require_once("MyCSV.class.php");

// Die Tabellen-Datei wird geladen.
if (isset($_SERVER['PHP_SELF'])) $PHP_SELF = $_SERVER['PHP_SELF'];
$tabellendatei = $PHP_SELF;
$tabellendatei = preg_replace('/(-neu)?\.\w*$/i', '', basename($tabellendatei));
$tabelle = new MyCSV($tabellendatei);

// Standardmig wird nach der ersten Spalte direkt hinter der ID-Nummer sortiert.
$sort = $tabelle->fields[1];
if (in_array(strtolower($tabelle->fields[1]), array("datum", "uhrzeit")))
{
    $sort .= " DESC";
}
$tabelle->sort($sort);

// Hier wird die Limitierung sowie die momentan angeklickte Seite eingestellt.
$tabelle->limit($datensaetze_je_seite);
if (isset($HTTP_GET_VARS['start'])) $start = $HTTP_GET_VARS['start'];
else $start = $tabelle->first();
$tabelle->seek(array_search($start, $tabelle->ids()));

// Alle Datenstze der Tabelle werden der Reihe nach durchgegangen.
while ($datensatz = $tabelle->each())
{
    // Jede ID muss mit einem Buchstaben beginnen und darf (fast) keine
    // Sonderzeichen enthalten.
    $id = $datensatz['id'];
    if (! preg_match('/^[a-z]/i', $id)) $id = "i" . $id;
    $id = preg_replace('/[^a-z0-9_-]+/is', '', $id);

    echo "<div class=\"datensatz\" id=\"" . $id . "\">\n";

    // Fr jeden Datensatz werden alle Spalten der Reihe nach durchgegangen.
    foreach ($tabelle->fields as $spaltenname)
    {
        // Die erste Spalte mit der ID-Nummer wird bersprungen.
        if (strtolower($spaltenname) == "id") continue;

        // Klassennamen drfen in erster Linie keine Leerzeichen enthalten.
        $class = preg_replace('/[^a-z0-9_-]+/is', '', $spaltenname);

        echo "  <div class=\"" . $class . "\">";
        echo nl2br(htmlspecialchars($datensatz[$spaltenname]));
        echo "</div>\n";
    }

    echo "</div>\n\n";
}

// Die Links zum Blttern anzeigen, falls bentigt.
echo "<div class=\"tabellennavigation\">\n";
if ($vorige = $tabelle->next($start, -$datensaetze_je_seite))
{
    echo "  <a href=\"" . $PHP_SELF . "?start=" . $vorige .
        "\">&lt; Vorige Seite</a>\n";
}
if ($naechste = $tabelle->next($start, $datensaetze_je_seite))
{
    echo "  <a href=\"" . $PHP_SELF . "?start=" . $naechste .
        "\">Nchste Seite &gt;</a>\n";
}
echo "</div>\n";

?>

  </body>
</html>